/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef __KERNEL_VERSION_H__
#define __KERNEL_VERSION_H__

/*****************************************************************************/
/*** DEFINES *****************************************************************/
/*****************************************************************************/


#define VERSION_CODE(version, release, build)                               \
        (((version) << 16) | ((release) << 8) | (build))
        
#ifndef LINUX_VERSION_CODE
#include <linux/version.h>
#endif
#if (VERSION_CODE(2,6,30) <= LINUX_VERSION_CODE)
#include <linux/sched.h>
#endif 
        

#if ((VERSION_CODE(2,0,0) <= LINUX_VERSION_CODE) && \
     (LINUX_VERSION_CODE < VERSION_CODE(2,2,0)) )
  #define set_current_timeout(timeout)                current->timeout = timeout

  #define GET_MINOR_BOARD()   MINOR (Inode->i_rdev) & PB_BOARD_SELECT
  #define GET_MINOR_TYPE()    MINOR (Inode->i_rdev) & PB_DEVICE_SELECT

  #define copy_from_user_to_io(dest, source, length)  memcpy_fromfs(dest, source, length)
  #define copy_from_user(dest, source, length)        memcpy_fromfs(dest, source, length)
  #define copy_from_io(dest, source, length)          memcpy_fromio(dest, source, length)

  #define copy_from_io_to_user(dest, source, length)  memcpy_tofs(dest, source, length)
  #define copy_to_user(dest, source, length)          memcpy_tofs(dest, source, length)
  #define copy_to_io(dest, source, length)            memcpy_toio(dest, source, length)

  #define compare_kernel_io(area1, area2, size)       memcmp(area1, area2, size)
  #define compare_io_kernel(area1, area2, size)       memcmp(area1, area2, size)

  #define read_io_byte(b)                             readb(b)
  #define read_io_word(b)                             readw(b)
  #define read_io_long(b)                             readl(b)
  #define write_io_byte(b, c)                         writeb(c, b)
  #define write_io_word(b, c)                         writew(c, b)
//   #define write_io_long(b, c)                         writel(c, b)

  #define proc_register(root, entry)                  proc_register_dynamic(root, entry)


#elif ((VERSION_CODE(2,2,0) <= LINUX_VERSION_CODE) && \
     (LINUX_VERSION_CODE < VERSION_CODE(2,4,0)) )
  #define set_current_timeout(timeout)

  #define io_remap(addr, size)                        ioremap (addr, size)
  #define io_unmap(addr)                              iounmap (addr)

  #define GET_MINOR_BOARD()   MINOR (file->f_dentry->d_inode->i_rdev) & PB_BOARD_SELECT
  #define GET_MINOR_TYPE()    MINOR (file->f_dentry->d_inode->i_rdev) & PB_DEVICE_SELECT

  #define copy_from_user_to_io(dest, source, length)  memcpy_toio(dest, source, length)
  #define copy_from_io(dest, source, length)          memcpy_fromio(dest, source, length)

  #define copy_from_io_to_user(dest, source, length)  memcpy_fromio(dest, source, length)
  #define copy_to_io(dest, source, length)            memcpy_toio(dest, source, length)

  #define compare_kernel_io(area1, area2, size)       memcmp(area1, area2, size)
  #define compare_io_kernel(area1, area2, size)       memcmp(area1, area2, size)

  #define read_io_byte(b)                             readb(b)
  #define read_io_word(b)                             readw(b)
  #define read_io_long(b)                             readl(b)
  #define write_io_byte(b, c)                         writeb(c, b)
  #define write_io_word(b, c)                         writew(c, b)
//   #define write_io_long(b, c)                         writel(c, b)

#elif ((VERSION_CODE(2,4,0) <= LINUX_VERSION_CODE) && \
     (LINUX_VERSION_CODE < VERSION_CODE(4,0,0)) )

  #define set_current_timeout(timeout)

  #define io_remap(addr, size)                        ioremap_nocache (addr, size)
  #define io_unmap(addr)                              iounmap (addr)

  #define GET_MINOR_BOARD()   MINOR (file->f_dentry->d_inode->i_rdev) & PB_BOARD_SELECT
  #define GET_MINOR_TYPE()    MINOR (file->f_dentry->d_inode->i_rdev) & PB_DEVICE_SELECT

  #define copy_from_user_to_io(dest, source, length)  memcpy_toio(dest, source, length)
  #define copy_from_io(dest, source, length)          memcpy_fromio(dest, source, length)

  #define copy_from_io_to_user(dest, source, length)  memcpy_fromio(dest, source, length)
  #define copy_to_io(dest, source, length)            memcpy_toio(dest, source, length)

  #define compare_kernel_io(area1, area2, size)       memcmp(area1, (void*) area2, size)
  #define compare_io_kernel(area1, area2, size)       memcmp((void*) area1, area2, size)

  #define read_io_byte(b)                             readb(b)
  #define read_io_word(b)                             readw(b)
  #define read_io_long(b)                             readl(b)
  #define write_io_byte(b, c)                         writeb(c, b)
  #define write_io_word(b, c)                         writew(c, b)
//   #define write_io_long(b, c)                         writel(c, b)

/*
  #define read_io_byte(b)                             (*((volatile char*) (b)))
  #define read_io_word(b)                             (*((volatile short*) (b)))
  #define read_io_long(b)                             (*((volatile long*) (b)))
  #define write_io_byte(b, c)                         { *((volatile char*) (b)) = (char)  c; }
  #define write_io_word(b, c)                         { *((volatile short*) (b)) = (short) c; }
  #define write_io_long(b, c)                         { *((volatile long*) (b)) = (long)  c; }
*/
  #define proc_register(root, entry)                  create_proc_dir_entry (THIS_MODULE, 0, root, entry, NULL)
  #define proc_unregister(root, entry)                remove_proc_entry (THIS_MODULE, NULL)

#endif

/*****************************************************************************/
/*** TYPEDEFS ****************************************************************/
/*****************************************************************************/



/*****************************************************************************/


#endif /* __KERNEL_VERSION_H__ */

/*** END OF KERNEL_VERSION.H *************************************************/
