/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef _XX_CONF_H_
#define _XX_CONF_H_

/* --- polling or interrupt mode --------------------------------------------*/
#define REQ_ACK_BY_POLLING             0  /* request and ackn. by polling    */
#define REQ_BY_IR_ACK_BY_POLLING       1  /* request by IR, ackn. by polling */
#define REQ_BY_POLLING_ACK_BY_IR       2  /* request by polling, ackn. by IR */
#define REQ_ACK_BY_IR                  3  /* request and acknowledge by IR   */

#define POLL_INT_MODE    REQ_ACK_BY_IR

/* --- address mode -------------------------------------------------------- */
#define ABS_32BIT_MOTOROLA             0  /* linear absolute 32 bit Motorola */
#define ABS_16BIT_MOTOROLA             1  /* linear absolute 16 bit Motorola */
#define REL_32BIT_MOTOROLA             2  /* linear relative 32 bit Motorola */
#define REL_16BIT_MOTOROLA             3  /* linear relative 16 bit Motorola */

#define ABS_32BIT_INTEL                8  /*  linear absolute 32 bit Intel   */
#define ABS_16BIT_INTEL                9  /*  linear absolute 16 bit Intel   */
#define REL_32BIT_INTEL               10  /*  linear relative 32 bit Intel   */
#define REL_16BIT_INTEL               11  /*  linear relative 16 bit Intel   */
#define SEGMENT_OFFSET_INTEL          12  /*  SEGEMENT/OFFSET Intel          */

#define ADDRESS_SWAP_MODE SEGMENT_OFFSET_INTEL


#define NO_INT_TO_HOST        0x00

#ifdef PB
#define INT_5                        0x10
#define INT_10                       0x20
#define INT_11                       0x30
#define INT_12                       0x40
#define INT_15                       0x50
#endif

#ifdef FF
#define INT_3                        0x10
#define INT_5                        0x20
#define INT_10                       0x30
#define INT_11                       0x40
#define INT_12                       0x50
#define INT_15                       0x60
#endif

#endif
