/******************************************************************************
*                                                                             *
*                                 SOFTING AG                                  *
*                          Richard-Reitzner-Allee 6                           *
*                                D-85540 Haar                                 *
*                        Phone: (++49)-(0)89-45656-0                          *
*                        Fax:   (++49)-(0)89-45656-399                        *
*                                                                             *
*                      Copyright (C) SOFTING AG 1997-2003                     *
*                              All Rights Reserved                            *
*                                                                             *
*******************************************************************************

FILE_NAME               DPV1DEMO.H

PROJECT_NAME            PROFIBUS

MODULE                  DPV1DEMO

COMPONENT_LIBRARY       --------

AUTHOR                  SOFTING AG

VERSION                 5.24

DATE                    31.07.2001


STATUS                  finished

FUNCTIONAL_MODULE_DESCRIPTION

DP/V1 Demo Application - Prototypes of all internal Functions

RELATED_DOCUMENTS

============================================================================*/

FUNCTION static VOID print_version
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print Version String                                                     */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_menu
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print Version String                                                     */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID error_exit
         (
           IN char FAR*  msg
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Exit Program with Message                                                */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_if_error
         (
           IN USIGN8 primitive,
           IN INT16  error
         );

/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print Interface error, get additional data if available                  */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_usage
  (
  IN    VOID
  );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Prints out a short help for the command-line options                     */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_papi_firmware_version
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print Papi-Version and Firmware-Version                                  */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 fmb_set_configuration
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Start Profibus DP                                                        */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 fmb_set_busparameter
         (
           IN USIGN8 ts
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Set Busparameters for a DP/V1 network                                    */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_initiate_req
         (
           IN USIGN16 send_timeout
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Start a DP/V1 connection                                                 */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_read_req
         (
           IN USIGN8 slot_number,
           IN USIGN8 index
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Read an Object from the slave with DP/V1 services                        */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_write_req
         (
           IN USIGN8 slot_number,
           IN USIGN8 index,
           IN USIGN8 len,
           IN USIGN8 *data
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Write ABCD into a slave object with DP/V1 services                       */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_abort_req
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Abort a DP/V1 connection                                                 */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_act_param_loc_req
         (
            VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Set the DP-Master into state STOP                                        */
/* ------------------------------------------------------------------------ */

FUNCTION static INT16 dp_init_master_req
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Start the DP-Task on the Controller                                      */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_dp_initiate_data
         (
           IN T_DP_INITIATE_CON FAR*   initiate_con_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print the received data from an initiate-response                        */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_dp_read_data
         (
           IN T_DP_READ_CON FAR*   read_con_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print DP/V1-Read-Confirmation and the first 8 Byte of the received data  */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_dp_write_data
         (
           IN T_DP_WRITE_CON FAR*   write_con_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print DP/V1-Write-Confirmation                                           */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_dp_abort_data
         (
           IN T_DP_ABORT_IND FAR*   abort_ind_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print DP/V1-Abort-Data and give hints for the errors which occur         */
/* rather often                                                             */
/* ------------------------------------------------------------------------ */

FUNCTION static char FAR* error_name
         (
           IN USIGN16 code
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Convert a DP-Error-Code into a corresponding String                      */
/* ------------------------------------------------------------------------ */

FUNCTION static char FAR* fmb_name
         (
           IN USIGN8 service
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Convert a FMB-Servic-Define into a corresponding String                  */
/* ------------------------------------------------------------------------ */

FUNCTION static char FAR* dp_name
         (
           IN USIGN8 service
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Convert a DP/V1-Servic-Define into a corresponding String                */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_pos_con
         (
           IN char FAR* service_name
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print a positive confirmation                                            */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_neg_dpv1_con
         (
           IN char FAR*           service_name,
           IN T_DP_ERROR_CON FAR* error_con_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print a negative DP/V1 confirmation and its parameters                   */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID print_neg_fmb_con
         (
           IN char FAR*       service_name,
           IN T_ERROR FAR*    error_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Print a negative FMB confirmation and its parameters                     */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID dp_ind_con
         (
           IN T_PROFI_SERVICE_DESCR FAR* sdb_ptr,
           IN char FAR*                  data_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Test a received DP-confirmation / indication and set the                 */
/* program state accordingly                                                */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID fmb_ind_con
         (
           IN T_PROFI_SERVICE_DESCR FAR* sdb_ptr,
           IN char FAR*                  data_ptr
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Test a received FMB-indication and increment the program state           */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID wait_for_cnf_ind
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Test whether a confirmation/indication was received and                  */
/* dispatch the received data according to it's layer                       */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID automatic_action
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Do all those things like polling the card according to the current state */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID user_action
         (
           IN USIGN8 action
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Do all the users requests                                                */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID dpv1_task
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* The program's main loop                                                  */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID check_options
         (
           IN    char    options []
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Analysis of the Users command line options                               */
/* ------------------------------------------------------------------------ */

FUNCTION static VOID set_default_options
         (
           VOID
         );
/* ------------------------------------------------------------------------ */
/* FUNCTIONAL_DESCRIPTION:                                                  */
/*                                                                          */
/* Initialize command-line Values to Default                                */
/* ------------------------------------------------------------------------ */

/****************************************************************************/
/**** EOF *******************************************************************/
/****************************************************************************/
